## lxc 4.0.12

=== meson_options.txt ===
# -*- mode: meson -*-

option('tests', type : 'boolean', value: 'false',
       description : 'enable tests')

option('runtime-path', type : 'string', value : '/run',
       description : 'the runtime directory')

option('init-script', type : 'combo',
       choices : ['systemd', 'sysvinit', 'openrc', 'upstart'], value : 'systemd',
       description : 'init script')

option('apparmor-cache-dir', type : 'string', value : 'cache/lxc/apparmor',
       description : 'the AppArmor cache directory')

option('rootfs-mount-dir', type : 'string', value : 'lib/x86_64-linux-gnu/lxc',
       description : 'the rootfs mount directory')

option('cgroup-pattern', type : 'string', value : '',
       description : 'the rootfs mount directory')

option('log-path', type : 'string', value : 'log/lxc',
       description : 'the rootfs mount directory')

option('config-path', type : 'string', value : 'lib/lxc',
       description : 'the rootfs mount directory')

option('global-config', type : 'string', value : 'lxc/lxc.conf',
       description : 'the rootfs mount directory')

option('docdir', type : 'string',
       description : 'documentation directory')

option('user-network-conf', type : 'string', value : 'lxc/lxc-usernet',
       description : 'user network interface configuration file')

option('user-network-db', type : 'string', value : 'lxc/nics',
       description : 'user network database')

option('io-uring-event-loop', type : 'boolean', value: 'false',
       description : 'enable io-uring based event loop')

=== debian/changelog ===
lxc (1:4.0.12-0ubuntu1~20.04.1) focal; urgency=medium

  * Cherry-pick upstream bugfixes (stable-4.0):
    - 0002-lxc-checkconfig-Fix-bashism.patch
    - 0003-doc-Fix-reverse-allowlist-denylist.patch

  * New upstream bugfix release (4.0.12) (LP: #1959993):
    (https://discuss.linuxcontainers.org/t/lxc-4-0-12-has-been-released/13288)
    - Fixed CRIU restoration of containers with pre-created veth interfaces
    - Fixed issue with kernels lacking SMT support
    - Extended cgroup2 config options in lxc.mount.auto (cgroup2)
    - lxc-download now relies on HTTPS for validation (avoids GPG issues)

  * New upstream bugfix release (4.0.11):
    (https://discuss.linuxcontainers.org/t/lxc-4-0-11-has-been-released/12427)
    - Core scheduling support (lxc.sched.core)
    - riscv64 support in lxc.arch
    - Significantly improved bash completion profile
    - Greater use of the new VFS mount API (when supported by the kernel)
    - Fix containers with empty network namespaces
    - Handle kernels that lack TIOCGPTPEER
    - Improve CPU bitmask/id handling (handle skipped CPU numbers)
    - Reworked the tests to run offline

  * New upstream bugfix release (4.0.10):
    (https://discuss.linuxcontainers.org/t/lxc-4-0-10-has-been-released/11618)
    - Fix issues with less common architectures
    - Support for additional idmap mounts
    - nft support in lxc-net
    - Cleaner mount entries for sys:mixed
    - Switched GPG server to keyserver.ubuntu.com

  * New upstream bugfix release (4.0.9):
    (https://discuss.linuxcontainers.org/t/lxc-4-0-9-has-been-released/10999)
    - Fix incorrect personality setting when running 32bit containers on 64bit

  * New upstream bugfix release (4.0.8):
    - Fix CGroup attach against older running containers

  * New upstream bugfix release (4.0.7):
    - Testing improvements including fixes from oss-fuzz
    - Rework of the attach codepath
    - Cgroup handling rework

  * Bump to debhelper 12 (allows focal SRUs)
  * Bump standards to 4.6.0.1
  * Add lintian overrides for incorrect bashism detection
  * Remove bash completion install logic (now done upstream)

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 03 Feb 2022 23:50:20 -0500

lxc (1:4.0.6-0ubuntu1~20.04.1) focal; urgency=medium

  * Backport hirsute fixes to focal. (LP: #1923232)

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Fri, 09 Apr 2021 11:19:38 -0500

=== debian/control ===
Source: lxc
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: bash-completion,
               debhelper (>= 12),
               dh-apparmor,
               docbook2x,
               dpkg-dev (>= 1.16.1~) | hardening-wrapper,
               libapparmor-dev (>= 2.8.96~2652-0ubuntu1),
               libcap-dev,
               libgnutls28-dev,
               libpam0g-dev,
               libseccomp-dev,
               libselinux1-dev,
               linux-libc-dev,
               pkg-config
Standards-Version: 4.6.0.1
Homepage: https://linuxcontainers.org
Vcs-Git: https://github.com/lxc/lxc-pkg-ubuntu
Vcs-Browser: https://github.com/lxc/lxc-pkg-ubuntu
Rules-Requires-Root: no

Package: lxc
Architecture: all
Depends: lxc-utils (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package - lxc -> lxc-utils
 This is a transitional dummy package. It can safely be removed.
 .
 lxc is now replaced by lxc-utils.

Package: lxc1
Architecture: all
Depends: lxc-utils (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package - lxc1 -> lxc-utils
 This is a transitional dummy package. It can safely be removed.
 .
 lxc1 is now replaced by lxc-utils.

Package: lxc-dev
Architecture: all
Depends: liblxc-dev (>= ${source:Version}), ${misc:Depends}
Section: oldlibs
Description: Transitional package - lxc-dev -> liblxc-dev
 This is a transitional dummy package. It can safely be removed.
 .
 lxc-dev is now replaced by liblxc-dev.

Package: lxc-utils
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         bridge-utils,
         dnsmasq-base,
         iptables,
         liblxc1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: libpam-cgfs
Suggests: btrfs-tools, lvm2, lxc-templates, lxctl
Replaces: lxc1 (<< 2.1.1-0ubuntu2~)
Breaks: lxc1 (<< 2.1.1-0ubuntu2~)
Description: Linux Containers userspace tools
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package provides the lxc-* tools, which can be used to start a single
 daemon in a container, or to boot an entire "containerized" system, and to
 manage and debug your containers.

Package: liblxc-common
Architecture: linux-any
Depends: liblxc1 (= ${binary:Version}),
         ${lxc:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: lxc-common
Replaces: lxc-common,
          lxc-templates (<< 3.0.0~beta1-0ubuntu1~),
          lxc-utils (<< 1:4.0.0-0ubuntu1~),
          lxc1 (<< 3.0.0~beta2-0ubuntu2~)
Breaks: lxc-templates (<< 3.0.0~beta1-0ubuntu1~),
        lxc-utils (<< 1:4.0.0-0ubuntu1~),
        lxc1 (<< 3.0.0~beta2-0ubuntu2~)
Provides: lxc-common
Description: Linux Containers userspace tools (common tools)
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package contains a few binaries and security profiles required by
 all liblxc users.

Package: liblxc-dev
Section: libdevel
Architecture: linux-any
Depends: liblxc1 (= ${binary:Version}), ${misc:Depends}
Replaces: lxc-dev (<< 2.1.1-0ubuntu2~)
Breaks: lxc-dev (<< 2.1.1-0ubuntu2~)
Description: Linux Containers userspace tools (development)
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package contains the development files.

Package: liblxc1
Architecture: linux-any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: cgroup-lite | systemd,
         liblxc-common (= ${binary:Version}),
         rsync,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: lxcfs, uidmap
Description: Linux Containers userspace tools (library)
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package contains the libraries.

Package: libpam-cgfs
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: libpam-runtime (>= 1.0.1-6),
         ${lxcfs:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: lxc-utils (<< 1:4.0.0-0ubuntu1~)
Breaks: lxc-utils (<< 1:4.0.0-0ubuntu1~)
Conflicts: libpam-cgm
Description: PAM module for managing cgroups for LXC
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This provides a Pluggable Authentication Module (PAM) to provide
 logged-in users with a set of cgroups which they can administer.
 This allows for instance unprivileged containers, and session
 management using cgroup process tracking.

## lxc 5.0.0~git2209-g5a7b9ce67

=== debian/changelog ===
lxc (1:5.0.0~git2209-g5a7b9ce67-0ubuntu1.1) jammy; urgency=medium

  [ Dave Jones ]
  * Fix the LXC_DEVEL value to be 0 (LP: #2039873)
    - d/p/0002-Set-DEVEL-flag-post-release.patch added to force this
      value in the autoconf script

  [ Alexander Mikhalitsyn ]
  * Added autopkgtest to ensure that LXC_DEVEL is always 0
    - debian/tests/no-devel: add "no-devel" autopkgtest script
    - debian/tests/control: declare "no-devel" autopkgtest

 -- Dave Jones <dave.jones@canonical.com>  Wed, 24 Jan 2024 16:26:06 +0000

lxc (1:5.0.0~git2209-g5a7b9ce67-0ubuntu1) jammy; urgency=medium

  * Pre-release snapshot of LXC 5.0 LTS (LP: #1967620)
    - New configuration keys:
      - lxc.cgroup.dir.monitor.pivot
      - lxc.cgroup.dir.monitor
      - lxc.cgroup.dir.container.inner
      - lxc.cgroup.dir.container
      - lxc.time.offset.boot
      - lxc.time.offset.monotonic
      - veth.n_rxqueues
      - veth.n_txqueues
      - veth.vlan.id
      - veth.vlan.tagged.id
  * Drop patches (now upstreamed):
    - 0002-lxc-checkconfig-Fix-bashism.patch
    - 0003-doc-Fix-reverse-allowlist-denylist.patch
  * Update lintian overrides for current lintian version
  * debian/control: Switch to debhelper-compat

 -- Stéphane Graber <stgraber@ubuntu.com>  Tue, 05 Apr 2022 18:07:22 -0400

lxc (1:4.0.12-0ubuntu2) jammy; urgency=medium

  * No-change rebuild to update maintainer scripts, see LP: 1959054

 -- Dave Jones <dave.jones@canonical.com>  Wed, 16 Feb 2022 17:06:54 +0000

lxc (1:4.0.12-0ubuntu1) jammy; urgency=medium
  * Cherry-pick upstream bugfixes (stable-4.0):
    - 0002-lxc-checkconfig-Fix-bashism.patch
    - 0003-doc-Fix-reverse-allowlist-denylist.patch (LP: #1957934)

  * New upstream bugfix release (4.0.12):
    (https://discuss.linuxcontainers.org/t/lxc-4-0-12-has-been-released/13288)
    - Fixed CRIU restoration of containers with pre-created veth interfaces
    - Fixed issue with kernels lacking SMT support
    - Extended cgroup2 config options in lxc.mount.auto (cgroup2)
    - lxc-download now relies on HTTPS for validation (avoids GPG issues)

  * New upstream bugfix release (4.0.11)
    (LP: #1943441, LP: #1938771, LP: #1891903):
    (https://discuss.linuxcontainers.org/t/lxc-4-0-11-has-been-released/12427)
    - Core scheduling support (lxc.sched.core)
    - riscv64 support in lxc.arch
    - Significantly improved bash completion profile
    - Greater use of the new VFS mount API (when supported by the kernel)
    - Fix containers with empty network namespaces
    - Handle kernels that lack TIOCGPTPEER
    - Improve CPU bitmask/id handling (handle skipped CPU numbers)
    - Reworked the tests to run offline

  * Bump to debhelper 12 (allows focal SRUs)
  * Bump standards to 4.6.0.1
  * Add lintian overrides for incorrect bashism detection
  * Remove bash completion install logic (now done upstream)

 -- Stéphane Graber <stgraber@ubuntu.com>  Wed, 02 Feb 2022 20:48:39 -0500

lxc (1:4.0.10-0ubuntu5) impish; urgency=medium

  * d/t/exercise: Skip tests that are incompatible with cgroups v2
    (LP: #1943704)

 -- Lukas Märdian <slyon@ubuntu.com>  Fri, 17 Sep 2021 15:00:26 +0200

lxc (1:4.0.10-0ubuntu4) impish; urgency=medium

  * Cherry-pick upstream bugfixes (stable-4.0):
    - 0002-cgroups-populate-hierarchy-for-device-cgroup.patch
    - 0003-cgroups-remove-unneeded-variables-from-cgroup_tree_c.patch
    - 0004-lxc_setup_ttys-Handle-existing-ttyN-file-without-und.patch
    - 0005-bpf-bpf_devices_cgroup_supported-should-check-if-bpf.patch
    - 0006-conf-use-new-mount-api-for-devpts-setup.patch
    - 0007-terminal-ttyname_r-returns-an-error-number-on-failur.patch
    - 0008-conf-ensure-devpts_fd-is-set-to-EBADF.patch
    - 0009-Fix-typos.patch
    - 0010-conf-surface-failures-to-setup-console.patch
    - 0011-conf-set-source-property-for-devpts.patch
    - 0012-conf-attach-devpts-mount-directly-when-new-mount-api.patch
    - 0013-conf-s-lxc_setup_devpts_parent-lxc_recv_devpts_from_.patch
    - 0014-conf-use-a-relative-path-in-symlinkat.patch
    - 0015-conf-update-comment.patch
    - 0016-conf-add-and-use-mount_beneath_fd.patch
    - 0017-terminal-don-t-use-ttyname_r-for-native-terminal-all.patch
    - 0018-conf-merge-devpts-setup-and-move-before-pivot-root.patch
    - 0019-string_utils-cast-__s64-to-long-long-signed-int.patch
    - 0020-terminal-split-out-lxc_devpts_terminal-helper.patch
    - 0021-conf-move-lxc_create_ttys-before-pivot-root.patch
    - 0022-conf-stash-pty_nr-in-struct-lxc_terminal.patch
    - 0023-mount_utils-add-mount_fd.patch
    - 0024-conf-use-mount_fd-helper-when-mounting-ttys.patch
    - 0025-conf-use-mount_fd-in-lxc_setup_dev_console.patch
    - 0026-conf-use-mount_fd-during-console-mounting.patch
    - 0027-file_utils-add-open_at_same.patch
    - 0028-conf-rework-console-setup.patch
    - 0029-terminal-remove-unused-argument-from-lxc_devpts_term.patch
    - 0030-start-allow-containers-to-use-a-native-console.patch
    - 0031-conf-handle-kernels-without-TIOCGPTPEER.patch
    - 0032-terminal-move-native-terminal-allocation-from-error-.patch
    - 0033-terminal-fail-on-unknown-error-during-TIOCGPTPEER.patch
    - 0034-mount_utils-introduce-mount_at.patch
    - 0035-conf-fix-logging-in-lxc_idmapped_mounts_child.patch
    - 0036-conf-refactor-lxc_recv_ttys_from_child.patch
    - 0037-conf-log-failure-to-create-tty-mountpoint.patch
    - 0038-conf-let-parse_vfs_attr-handle-legacy-mount-flags-as.patch
    - 0039-mount_utils-make-some-mount-helpers-static-inline.patch
    - 0040-conf-allow-mount-options-for-rootfs-when-using-new-m.patch
    - 0041-tests-add-test-for-rootfs-mount-options.patch
    - 0042-network-fix-container-with-empty-network-namespaces.patch
    - 0043-lsm-apparmor-log-failure-to-write-AppArmor-profile.patch
    - 0044-lsm-apparmor-use-cleanup-macro.patch
    - 0045-doc-api-extensions-Grammar-fix.patch

 -- Stéphane Graber <stgraber@ubuntu.com>  Mon, 09 Aug 2021 13:45:59 -0400

lxc (1:4.0.10-0ubuntu3) impish; urgency=medium



=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_HARDENING = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/default.mk

DEB_DH_INSTALLINIT_ARGS = --upstart-only

SHELL := sh -e

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh ${@}

override_dh_auto_configure:
	dh_auto_configure -- --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--libexecdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--with-rootfs-path=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)/lxc \
		$(shell dpkg-buildflags --export=configure) \
		--enable-doc --disable-rpath --with-distro=ubuntu --enable-pam

override_dh_install:
	if [ -x /usr/bin/dh_apparmor ]; then \
		dh_apparmor -p liblxc-common --profile-name=usr.bin.lxc-start; \
	fi

	# libpam-cgfs
	mkdir -p debian/tmp/usr/share/pam-configs/
	cp debian/libpam-cgfs.pam debian/tmp/usr/share/pam-configs/cgfs

	# cleanup .la files
	find debian/tmp/ -type f -name \*.la -delete

	# copy apport hook
	mkdir -p debian/tmp/usr/share/apport/package-hooks
	cp debian/lxc-utils.apport debian/tmp/usr/share/apport/package-hooks/source_lxc.py

	# copy dnsmasq configuration
	mkdir -p debian/tmp/etc/dnsmasq.d-available
	cp debian/lxc-utils.dnsmasq debian/tmp/etc/dnsmasq.d-available/lxc

	# move the examples
	mv debian/tmp/usr/share/doc/lxc debian/tmp/usr/share/doc/liblxc-common

	# move the special manpages
	mkdir -p debian/libpam-cgfs/usr/share/man/man8/
	mkdir -p debian/libpam-cgfs/usr/share/man/ja/man8/
	mv debian/tmp/usr/share/man/man8/pam_cgfs.8 debian/libpam-cgfs/usr/share/man/man8/
	mv debian/tmp/usr/share/man/ja/man8/pam_cgfs.8 debian/libpam-cgfs/usr/share/man/ja/man8/
	rmdir debian/tmp/usr/share/man/man8 debian/tmp/usr/share/man/ja/man8

	mkdir -p debian/liblxc-common/usr/share/man/man1/
	mkdir -p debian/liblxc-common/usr/share/man/ja/man1/
	mkdir -p debian/liblxc-common/usr/share/man/ko/man1/
	mv debian/tmp/usr/share/man/man1/lxc-user-nic.1 debian/liblxc-common/usr/share/man/man1/
	mv debian/tmp/usr/share/man/ja/man1/lxc-user-nic.1 debian/liblxc-common/usr/share/man/ja/man1/
	mv debian/tmp/usr/share/man/ko/man1/lxc-user-nic.1 debian/liblxc-common/usr/share/man/ko/man1/

	dh_install

override_dh_builddeb:
	# prevent system users from using setuid-root binaries under /var/lib/lxc
	chmod 700 debian/lxc-utils/var/lib/lxc
	chmod 700 debian/lxc-utils/var/cache/lxc

	# mark lxc-user-nic as setuid
	chmod u+s debian/liblxc-common/usr/lib/${DEB_HOST_MULTIARCH}/lxc/lxc-user-nic

	dh_builddeb

override_dh_installinit:
ifeq (,$(findstring $(DEB_DISTRIBUTION), trusty xenial))
	# Disable upstart integration on artful+
	cp debian/lxc-utils.maintscript.in debian/lxc-utils.maintscript
	rm -f debian/lxc-utils/etc/init/*.conf
else
	cp debian/lxc-utils/etc/init/lxc.conf debian/lxc-utils.upstart
	cp debian/lxc-utils/etc/init/lxc-instance.conf debian/lxc-utils.lxc-instance.upstart
	cp debian/lxc-utils/etc/init/lxc-net.conf debian/lxc-utils.lxc-net.upstart
	dh_installinit --no-start --no-stop-on-upgrade --name=lxc-instance
endif
	dh_installinit --no-stop-on-upgrade --name=lxc
	dh_installinit --no-stop-on-upgrade --name=lxc-net

override_dh_installsystemd:
	dh_installsystemd --no-stop-on-upgrade

=== debian/tests/control ===
Tests: no-devel
Depends: liblxc-dev
Restrictions: allow-stderr

Tests: exercise
Depends: autoconf,
         busybox-static,
         cloud-image-utils,
         debootstrap,
         dirmngr,
         distro-info,
         lxcfs,
         uidmap,
         xz-utils,
         @builddeps@,
         @
Restrictions: needs-root allow-stderr isolation-machine

## lxc 5.0.1

=== meson_options.txt ===
# -*- mode: meson -*-

# Main options
# was --cgroup-pattern in autotools
option('cgroup-pattern', type: 'string', value: '',
       description: 'CGroup pattern')

# was --coverity-build in autotools
option('coverity-build', type: 'boolean', value: 'true',
       description: 'build for coverity')

# was --{disable,enable}-examples in autotools
option('examples', type: 'boolean', value: 'true',
       description: 'build and install examples')

# was --init-script in autotools
option('init-script', type : 'array',
       choices : ['systemd', 'sysvinit', 'upstart'], value : ['systemd'],
       description : 'init script')

# was --{disable,enable}-liburing in autotools
option('io-uring-event-loop', type: 'boolean', value: 'false',
       description: 'Enable io-uring based event loop')

option('sd-bus', type: 'feature', value: 'auto',
       description: 'Enable linking against sd-bus')

# was --{disable,enable}-doc in autotools
option('man', type: 'boolean', value: 'true',
       description: 'build and install manpages')

# was --{disable,enable}-pam in autotools
option('pam-cgroup', type: 'boolean', value: 'false',
       description: 'build and install the pam cgroup module')

# was --{disable,enable}-tools in autotools
option('tools', type: 'boolean', value: 'true',
       description: 'build and install tools')

# was --{disable,enable}-commands in autotools
option('commands', type: 'boolean', value: 'true',
       description: 'build and install commands')

# was --{disable,enable}-capabilities in autotools
option('capabilities', type: 'boolean', value: 'true',
       description: 'use capabilities')

# was --{disable,enable}-seccomp in autotools
option('seccomp', type: 'boolean', value: 'true',
       description: 'use seccomp')

# was --{disable,enable}-apparmor in autotools
option('apparmor', type: 'boolean', value: 'true',
       description: 'use apparmor')

# was --{disable,enable}-openssl in autotools
option('openssl', type: 'boolean', value: 'true',
       description: 'use openssl')

# was --{disable,enable}-selinux in autotools
option('selinux', type: 'boolean', value: 'true',
       description: 'use selinux')

# was --{disable,enable}-tests in autotools
option('tests', type: 'boolean', value: 'false',
       description: 'build and install tests')

# Paths
# was --apparmor-cache-dir in autotools
option('apparmor-cache-path', type: 'string', value: 'cache/lxc/apparmor',
       description: 'AppArmor cache directory')

# was --with-config-path in autotools
option('data-path', type: 'string', value: 'lib/lxc',
       description: 'Container storage directory')

# was --with-doc-dir in autotools
option('doc-path', type: 'string', value: 'doc/lxc',
       description: 'Documentation directory')

# was --with-global-conf in autotools
option('global-config-path', type: 'string', value: 'lxc',
       description: 'Global configuration directory')

# was --log-path in autotools
option('log-path', type: 'string', value: 'log/lxc',
       description: 'Loging directory')

# was --with-rootfs-path in autotools
option('rootfs-mount-path', type: 'string', value: 'lxc/rootfs',
       description: 'Container rootfs mount directory')

# was --with-runtime-path in autotools
option('runtime-path', type: 'string', value: '/run',
       description: 'Main runtime directory')

# was --with-usernic-conf in autotools
option('usernet-config-path', type: 'string', value: 'lxc/lxc-usernet',
       description: 'User network configuration file path')

# was --with-usernic-db in autotools
option('usernet-db-path', type: 'string', value: 'lxc/nics',
       description: 'User network database file path')

option('oss-fuzz', type : 'boolean', value : 'false',
       description : 'build against oss-fuzz')

# was --{disable,enable}-thread-safety in autotools
option('thread-safety', type : 'boolean', value : 'true',
       description : 'whether the build fails when thread-safe logging cannot be guaranteed')

# was --{disable,enable}-memfd-rexec in autotools
option('memfd-rexec', type : 'boolean', value : 'true',
       description : 'whether to rexec the lxc-attach binary when attaching to a container')

=== debian/changelog ===
lxc (1:5.0.1-0ubuntu7) mantic; urgency=medium

  * Update apparmor profile to support new userns feature (LP: #2035315)
    - d/p/apparmor-userns.patch: Add userns permission to
      start-container abstraction and declare new 4.0 ABI in
      the usr.bin.lxc-start apparmor profile
    - debian/control: Declare Breaks on anything less than apparmor
      4.0.0~alpha2-0ubuntu4 for liblxc-common to ensure if apparmor is
      installed that it supports the new 4.0 ABI and add systemd-dev to
      Build-Depends to fix local build failure.

 -- Alex Murray <alex.murray@canonical.com>  Mon, 18 Sep 2023 13:28:16 +0930

lxc (1:5.0.1-0ubuntu6) lunar; urgency=medium

  * debian/control: add libcap-dev, libselinux1-dev, and libseccomp-dev to
    depends for liblxc-dev, to fix go-lxc autopktest failure.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Thu, 19 Jan 2023 17:53:14 -0600

lxc (1:5.0.1-0ubuntu5) lunar; urgency=medium

  * disable lxc-test-fuzzers - the test is failing to download external
    artifacts

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 17 Jan 2023 21:44:40 -0600

lxc (1:5.0.1-0ubuntu4) lunar; urgency=medium

  * Fix meson build in debian/tests/exercise: specify the rest of the
    required configuration parameters.
  * d/p/test-usernic-fixes:
    - drop the hunks dealing with cgroups.  lxc uses the systemd api
      to do that.
    - ifconfig is not available, use ip

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Mon, 16 Jan 2023 21:32:01 -0600

lxc (1:5.0.1-0ubuntu3) lunar; urgency=medium

  * fix meson reconfiguration usage: the build/ directory doesn't exist
    yet when tests/exercise runs, so use meson setup to create it.

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Sun, 15 Jan 2023 22:53:15 -0600

lxc (1:5.0.1-0ubuntu2) lunar; urgency=medium

  * Fix autopkg tests to use meson instead of autoconf

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Tue, 10 Jan 2023 16:21:26 -0600

lxc (1:5.0.1-0ubuntu1) lunar; urgency=medium

  * Update to lxc-5.0.1 (using the orig tarball from debian)
  * d/p: add all patches up to current git master
  * d/control: add libsystemd-dev and meson
  * d/rules: follow guidance from daily packaging
  * remove d/.git-dpm
  * update paths in liblxc1.install and liblxc.lintian-overrides

 -- Serge Hallyn <serge.hallyn@ubuntu.com>  Wed, 16 Nov 2022 09:31:08 -0600

lxc (1:5.0.0~git2209-g5a7b9ce67-0ubuntu3) kinetic; urgency=medium

  * d/p/ppc64el-gcc12-warning.patch: refine the patch to be less brittle in
    case of upstream changes

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 07 Sep 2022 10:19:55 +0200

lxc (1:5.0.0~git2209-g5a7b9ce67-0ubuntu2) kinetic; urgency=medium

  * d/p/lp1987625/*.patch: cherry-picked to fix FTBFS against glibc 2.36
    (LP: #1987625)
  * d/p/ppc64el-gcc12-warning.patch: work around a false positive warning in
    GCC 12 on ppc64el due to it defaulting to -O3

 -- Simon Chopin <schopin@ubuntu.com>  Fri, 26 Aug 2022 11:18:18 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: bash-completion,
-               debhelper (>= 12),
+               debhelper-compat (= 12),
                dh-apparmor,
                docbook2x,
                dpkg-dev (>= 1.16.1~) | hardening-wrapper,
@@ -13,8 +13,11 @@
                libpam0g-dev,
                libseccomp-dev,
                libselinux1-dev,
+	       libsystemd-dev,
                linux-libc-dev,
-               pkg-config
+               meson,
+               pkg-config,
+               systemd-dev
 Standards-Version: 4.6.0.1
 Homepage: https://linuxcontainers.org
 Vcs-Git: https://github.com/lxc/lxc-pkg-ubuntu
@@ -85,7 +88,8 @@
           lxc1 (<< 3.0.0~beta2-0ubuntu2~)
 Breaks: lxc-templates (<< 3.0.0~beta1-0ubuntu1~),
         lxc-utils (<< 1:4.0.0-0ubuntu1~),
-        lxc1 (<< 3.0.0~beta2-0ubuntu2~)
+        lxc1 (<< 3.0.0~beta2-0ubuntu2~),
+        apparmor (<< 4.0.0~alpha2-0ubuntu4~)
 Provides: lxc-common
 Description: Linux Containers userspace tools (common tools)
  Containers are insulated areas inside a system, which have their own namespace
@@ -99,7 +103,11 @@
 Package: liblxc-dev
 Section: libdevel
 Architecture: linux-any
-Depends: liblxc1 (= ${binary:Version}), ${misc:Depends}
+Depends: liblxc1 (= ${binary:Version}),
+         libcap-dev,
+         libseccomp-dev,
+         libselinux1-dev,
+         ${misc:Depends}
 Replaces: lxc-dev (<< 2.1.1-0ubuntu2~)
 Breaks: lxc-dev (<< 2.1.1-0ubuntu2~)
 Description: Linux Containers userspace tools (development)

=== debian/rules ===
--- 
+++ 
@@ -10,14 +10,12 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 %:
-	dh ${@}
+	dh ${@} --buildsystem=meson
 
 override_dh_auto_configure:
-	dh_auto_configure -- --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
-		--libexecdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
-		--with-rootfs-path=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)/lxc \
-		$(shell dpkg-buildflags --export=configure) \
-		--enable-doc --disable-rpath --with-distro=ubuntu --enable-pam
+	dh_auto_configure -- -Dman=true -Dpam-cgroup=true \
+		-Dlibexecdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
+		-Dinit-script=systemd,sysvinit,upstart
 
 override_dh_install:
 	if [ -x /usr/bin/dh_apparmor ]; then \
@@ -41,6 +39,10 @@
 
 	# move the examples
 	mv debian/tmp/usr/share/doc/lxc debian/tmp/usr/share/doc/liblxc-common
+
+	# move the PAM module
+	mkdir -p debian/tmp/lib/$(DEB_HOST_MULTIARCH)/
+	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/security/ debian/tmp/lib/$(DEB_HOST_MULTIARCH)/
 
 	# move the special manpages
 	mkdir -p debian/libpam-cgfs/usr/share/man/man8/

## lxc 5.0.2

=== debian/changelog ===
lxc (1:5.0.2-1+deb12u3) bookworm; urgency=medium

  * Cherry-pick upstream fix for null pointer dereference when using a shared
    rootfs (See #1085241)

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 03 Jan 2025 00:53:50 +0000

lxc (1:5.0.2-1+deb12u2) bookworm; urgency=medium

  * Cherry-pick upstream fix for creating ephemeral copies (See #1001713)

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 30 Nov 2023 01:17:33 +0000

lxc (1:5.0.2-1+deb12u1) bookworm; urgency=medium

  * Cherry-pick upstream "fix nftables syntax for IPv6 NAT" (Closes: #1049976)
  * Adjust branch in d/gbp.conf

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 22 Sep 2023 16:35:52 +0000

lxc (1:5.0.2-1) unstable; urgency=medium

  * New upstream release
    - Fixes CVE-2022-47952
    - Drop glibc 2.36 patch applied upstream
  * Bump Standards-Version in d/control (no changes needed)
  * Refresh d/copyright

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 17 Jan 2023 02:53:00 +0000

lxc (1:5.0.1-2) unstable; urgency=medium

  * d/control:
    - Add myself to Uploaders
    - Bump Standards-Version (no changes needed)
    - Set minimum required meson version in Build-Depends (Closes: #1016523)
    - Update list of architectures missing libseccomp-dev
    - Add Rules-Requires-Root: binary-targets
  * Add myself to d/copyright
  * d/liblxc1.symbols:
    - Avoid build failure due to missing symbols on architectures without
      libseccomp-dev (Closes: #922545)
  * Drop d/patches/0006-adjust-pam-dir.patch and modify d/libpam-cgfs.install
    to directly install pam_cgfs.so
  * Cherry-pick upstream fixes for building with glibc 2.36 (Closes: #1023437)
  * Add d/upstream/metadata
  * Remove asterisk from NEWS file to silence lintian tag

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 04 Nov 2022 19:54:47 +0000

lxc (1:5.0.1-1) unstable; urgency=medium

  * Team upload

  [ Mathias Gibbens ]
  * New upstream release 5.0.1 (Closes: #1005099, #1010843, #1006353)
    - Switch to meson build system and update d/rules as needed
    - Update Build-Depends and Depends in d/control
    - Drop patches no longer needed / applied upstream
    - Add patch to fix installed location of libpam_cgfs.so
    - Update d/liblxc-common.lintian-overrides
    - Update d/liblxc1.symbols

  [ Antonio Terceiro ]
  * debian/rules: drop handling of bash completion links

  [ Pierre-Elliott Bécue ]
  * Apply Janitor's changes on d/control constraints.
  * Fix debian/liblxc1.symbols
  * d/p/0004: Add a patch to make systemd security features working in nesting
    apparmor profile.
    This can cause security risks in privileged containers, so it's only in
    nesting profile. (Closes: #995350)

 -- Mathias Gibbens <mathias@calenhad.com>  Mon, 01 Aug 2022 22:46:52 +0200

lxc (1:4.0.11-1) unstable; urgency=medium

  * Backporting changes from experimental to unstable
  * d/control: Move from Conflicts + Breaks to Breaks + Replaces

 -- Pierre-Elliott Bécue <peb@debian.org>  Mon, 14 Feb 2022 00:22:35 +0100

lxc (1:4.0.11-1~exp4) experimental; urgency=medium

  * d/copyright: Clean the mess and extract as much as possible from the files
    in the repo (Closes: #1004978)
  * wrap-and-sort

 -- Pierre-Elliott Bécue <peb@debian.org>  Fri, 04 Feb 2022 23:06:35 +0100

lxc (1:4.0.11-1~exp3) experimental; urgency=medium

  * d/control: Update the dependency of lxc from liblxc1 to liblxc-common.

 -- Pierre-Elliott Bécue <peb@debian.org>  Wed, 02 Feb 2022 22:37:20 +0100

lxc (1:4.0.11-1~exp2) experimental; urgency=medium

  * d/control:
    - Fix some architecture screwups on liblxc-common
  * d/{liblxc-common,lxc}.install: Move /usr/lib/*/lxc/rootfs to the former

 -- Pierre-Elliott Bécue <peb@debian.org>  Sat, 29 Jan 2022 11:10:23 +0100

lxc (1:4.0.11-1~exp1) experimental; urgency=medium

  [ Pierre-Elliott Bécue ]
  * New upstream release 4.0.11
  * d/control:
    - Remove bridge-utils from lxc's dependencies and prioritize nftables over
      iptables as a firewalling dependency (Closes: #908050)
    - Bumps Standards-Version to 4.6.0
  * Create a new binary package liblxc-common to host the shared components
    needed by both bin:lxc and a potential future bin:lxd (Closes: #1002564)
  * d/liblxc1.symbols: updated
  * d/README.Debian: fix a misleading comment
  * d/copyright: updated years, and added missing copyright holders

  [ Antonio Terceiro ]
  * d/rules: re-enable installation of lxc-top (Closes: #1003591)

  [ Diederik de Haas ]
  * d/lxc.postinst: replace the use of which by a call to command -v

 -- Pierre-Elliott Bécue <peb@debian.org>  Fri, 28 Jan 2022 20:23:34 +0100

lxc (1:4.0.10-2) unstable; urgency=medium

  [ Antonio Terceiro ]
  * debian/rules: re-enable installation of lxc-top (Closes: #1003591)
  * Drop dependency on bridge-utils (Closes: #1004733)
  * lxc-net: don't start by default inside lxc
  * autopkgtest: add basic create/destroy test

  [ Diederik de Haas ]
  * Replace deprecated 'which' with 'command -v'

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 02 Feb 2022 15:45:10 -0300

lxc (1:4.0.10-1) unstable; urgency=medium

  * New upstream version 4.0.10
    - Builds fine against autoconf 2.70 (Closes: #978862)
  * Refresh patches.
    0007-conf-fix-containers-retaining-CAP_NET_ADMIN.patch dropped, applied
    upstream.
  * Update debian/liblxc1.symbols

 -- Antonio Terceiro <terceiro@debian.org>  Fri, 27 Aug 2021 09:15:30 -0300

=== debian/control ===
Source: lxc
Section: admin
Priority: optional
Maintainer: pkg-lxc <pkg-lxc-devel@lists.alioth.debian.org>
Uploaders: Antonio Terceiro <terceiro@debian.org>,
           Evgeni Golov <evgeni@debian.org>,
           Pierre-Elliott Bécue <peb@debian.org>,
           Mathias Gibbens <gibmat@debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 13),
               dh-apparmor,
               dh-exec,
               docbook2x,
               doxygen,
               graphviz,
               libapparmor-dev,
               libcap-dev,
               libgnutls28-dev,
               liblua5.2-dev,
               libpam0g-dev,
               libseccomp-dev [!alpha !ia64 !m68k !sh4 !sparc64],
               libselinux-dev,
               linux-libc-dev,
               meson (>= 0.61),
               pkg-config,
               systemd
Standards-Version: 4.6.2
Homepage: https://linuxcontainers.org/
Vcs-Git: https://salsa.debian.org/lxc-team/lxc.git
Vcs-Browser: https://salsa.debian.org/lxc-team/lxc
Rules-Requires-Root: binary-targets

Package: lxc
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: dnsmasq-base,
         iproute2,
         liblxc-common (= ${binary:Version}),
         lsb-base,
         nftables | iptables,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: apparmor,
            debootstrap,
            dirmngr,
            gnupg,
            libpam-cgfs,
            lxc-templates,
            lxcfs,
            openssl,
            rsync,
            uidmap,
            wget
Suggests: btrfs-progs, lvm2, python3-lxc
Description: Linux Containers userspace tools
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package provides the lxc-* tools, which can be used to start a single
 daemon in a container, or to boot an entire "containerized" system, and to
 manage and debug your containers.

Package: lxc-dev
Section: libdevel
Architecture: linux-any
Depends: libcap-dev,
         liblxc1 (= ${binary:Version}),
         libseccomp-dev [!alpha !ia64 !m68k !sh4 !sparc64],
         libselinux-dev,
         lxc (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Linux Containers userspace tools (development)
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package contains the development files.

Package: lxc-tests
Architecture: linux-any
Depends: liblxc1 (= ${binary:Version}),
         lxc (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Linux Containers userspace tools (test binaries)
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package contains the test binaries. Those binaries are primarily
 used for autopkgtest and by some developers. They are not meant to be
 installed on regular user systems.

Package: liblxc1
Section: libs
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: cgroupfs-mount | systemd
Description: Linux Containers userspace tools (library)
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package contains the shared library.

Package: liblxc-common
Section: libs
Architecture: linux-any
Depends: liblxc1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Breaks: lxc (<< 1:4.0.11-1~)
Replaces: lxc (<< 1:4.0.11-1~)
Description: Linux Containers userspace tools (library)
 Containers are insulated areas inside a system, which have their own namespace
 for filesystem, network, PID, IPC, CPU and memory allocation and which can be
 created using the Control Group and Namespace features included in the Linux
 kernel.
 .
 This package contains the common files for the shared library

Package: libpam-cgfs
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpam-runtime,
         ${lxcfs:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: libpam-cgm
Description: PAM module for managing cgroups for LXC
 LXCFS provides a FUSE based filesystem to improve the LXC experience
 within the containers.
 .
 This provides a Pluggable Authentication Module (PAM) to provide
 logged-in users with a set of cgroups which they can administer.
 This allows for instance unprivileged containers, and session
 management using cgroup process tracking.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh ${@} --buildsystem=meson

override_dh_auto_configure:
	dh_auto_configure -- \
		-Dman=true \
		-Dapparmor=true \
		-Dselinux=true \
		-Dcapabilities=true \
		-Dexamples=true \
		-Dpam-cgroup=true \
		-Dtests=true \
		-Dinit-script=sysvinit,systemd

override_dh_auto_build:
	dh_auto_build
	# See https://github.com/lxc/lxc/issues/4156
	cd doc/api/ && doxygen

override_dh_auto_install:
	dh_auto_install

	# install pam config
	cp $(CURDIR)/debian/pam-cgfs.config \
		$(CURDIR)/debian/libpam-cgfs/usr/share/pam-configs/cgfs

	# cleanup .la files
	find debian/tmp/ -type f -name \*.la -delete
	find debian/tmp/ -type f -name \*.a -delete

	# move the tests
	mkdir -p debian/lxc-tests/usr/bin
	mv debian/tmp/usr/bin/lxc-test-* debian/lxc-tests/usr/bin/

	# increase limit of inotify listeners
	mkdir -p debian/tmp/etc/sysctl.d
	cp debian/lxc.sysctl debian/tmp/etc/sysctl.d/30-lxc-inotify.conf

	# fix the sysvinit script name
	mv $(CURDIR)/debian/tmp/etc/init.d/lxc-containers \
		$(CURDIR)/debian/tmp/etc/init.d/lxc

	dh_apparmor -p liblxc-common --profile-name=usr.bin.lxc-start

override_dh_compress:
	dh_compress -X.cfg

override_dh_fixperms:
	dh_fixperms -Xusr/libexec/lxc/lxc-user-nic

override_dh_installinit:
	dh_installinit -p lxc --onlyscripts --no-stop-on-upgrade --no-start --name lxc
	dh_installinit -p lxc --onlyscripts --no-stop-on-upgrade --no-start --name lxc-net

override_dh_installsystemd:
	dh_installsystemd --no-stop-on-upgrade

override_dh_missing:
	dh_missing --fail-missing

=== debian/tests/control ===
Tests: exercise
Depends: busybox-static,
         debootstrap,
         dirmngr,
         dnsmasq-base,
         file,
         gnupg,
         iptables,
         lsb-release,
         rsync,
         uidmap,
         xz-utils,
         @
Restrictions: needs-root allow-stderr isolation-machine

Tests: unprivileged-containers
Depends: distro-info, uidmap, wget, @
Restrictions: allow-stderr, isolation-machine, needs-internet

Tests: basics-create-destroy
Depends: @, busybox-static
Restrictions: allow-stderr, needs-root, superficial
